﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication26
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 1000; i++)
            {
                this.ultraDataSource1.Rows.Add(new object[] { "First Grid Row " + i.ToString() });
                this.ultraDataSource2.Rows.Add(new object[] { "Ssecond Grid Row " + i.ToString() });
            }

            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand, AutoResizeColumnWidthOptions.All);
            this.ultraGrid2.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand, AutoResizeColumnWidthOptions.All);

            RowHeightSynchCreationFilter rowHeightSynchCreationFilter = new RowHeightSynchCreationFilter(this.ultraGrid1, this.ultraGrid2);
            this.ultraGrid1.CreationFilter = rowHeightSynchCreationFilter;
            this.ultraGrid2.CreationFilter = rowHeightSynchCreationFilter;
        }

        private void ultraGrid1_AfterRowRegionScroll(object sender, Infragistics.Win.UltraWinGrid.RowScrollRegionEventArgs e)
        {
            this.SynchGridScrolling((UltraGrid)sender);
        }

        private void ultraGrid2_AfterRowRegionScroll(object sender, Infragistics.Win.UltraWinGrid.RowScrollRegionEventArgs e)
        {
            this.SynchGridScrolling((UltraGrid)sender);
        }

        private void SynchGridScrolling(UltraGrid grid)
        {
            UltraGrid otherGrid = grid == this.ultraGrid1
                ? this.ultraGrid2
                : this.ultraGrid1;

            int firstRowIndex = grid.ActiveRowScrollRegion.FirstRow.Index;
            otherGrid.ActiveRowScrollRegion.FirstRow = otherGrid.Rows[firstRowIndex];
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSizing = RowSizing.AutoFree;
        }

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSizing = RowSizing.AutoFree;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.Rows[5].Cells[0].Appearance.FontData.SizeInPoints += 10;
            this.ultraGrid1.Rows[5].PerformAutoSize();
        }
    }

    public class RowHeightSynchCreationFilter : IUIElementCreationFilter
    {
        UltraGrid grid1;
        UltraGrid grid2;

        public RowHeightSynchCreationFilter( UltraGrid grid1, UltraGrid grid2)
        {
            this.grid1 = grid1;
            this.grid2 = grid2;
        }

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            RowUIElement rowUIElement = parent as RowUIElement;
            if (null != rowUIElement)
            {
                UltraGrid grid = parent.Control as UltraGrid;

                UltraGrid otherGrid = grid == this.grid1
                ? this.grid2
                : this.grid1;
                                
                UltraGridRow row = rowUIElement.Row;
                int index = row.Index;

                UltraGridRow otherRow = otherGrid.Rows[index];
                otherRow.Height = row.Height;
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing. 
            return false;
        }
    }

}
